	       TrekMuse Space Docs V1.0  30 Oct 92

Note:  These docs represent a compilation of the online help available
on TrekMuse relating to space.  Additional comments are clearly marked.
They aren't simply fixed in the text because I want to draw attention
specifically to the silly things that the docs have in them for the
benefit of those who want to know what the silly things are without
having to read the WHOLE thing. 

Overview:
     Within the 'reality' of TrekMuse, there are two kinds of space,
simulator space and 'real' space.  Simulator space is essentially a big
VR wargame that is intended purely for training and has no real bearing
on the Muse.  No treaties have effect in sim space.  Ships that are
destroyed come back in a few minutes, and players who are on ships that
get scorched suffer no penalties expect perhaps some annoying gloating
on the war channel.

     Real space is A Different Ballgame.  Real space is set up
independently of sim space, and ships cannot move between the two.
Ships that get blown up in real space are dead for good and get
@destroyed soon thereafter.

Miscellaneous:

     Within the muse, online help is available on many topics.	Start
with 'help space' and go from there.

     There are ten different sim spaces, numbered 0 through 9.	Spaces 2
through nine are reserved to the various empires for closed training.
Spaces 0 and 1 are available to most simulators.  Space 0 is where most
of the fighting is.  While it's nice to be polite, any ship in sim space
is likely to get scorched on sight.  Sim space initializers can prevent
this problem.

     If you don't want to start right in the middle of a battle, use an
initializer.  One can generally be found outside most simulator bridges.
To use it, pick it up and carry it with you to the bridge of the ship
you want to adjust.  Commands to change spaces and select your starting
position within a given space are listen in the @desc.


General:

A ship's reactor produces a certain amount of energy every six second
tactical turn.	This energy is given to helm, navigation, and batteries
as dictated by the engineering allocation.  Energy allocated to
navigation is further distributed to warp drives and/or the four shields
per the nav allocation, and power to helm is given to phasers/disruptors
and photons.  Energy production happens every turn, and systems that are
allocated energy will receive that energy every turn as long as
engineering can keep the supply going.

To man any console, just attempt to 'get' or 'take' it, or use the
command 'man <console name>'.

To leave any console, disconnect, leave the room, or type 'unman
<console name>'.

Engineering:

The matter/antimatter reactor on a ship produces a certain amount of
power per tactical turn.  This is assigned to three places: helm, nav,
and batteries.	This allocation will remain constant unless there is a
change in the reactor setting.	If the setting is raised, more power
will become available and the engineer should reallocate.  If the
setting drops below the allocated energy, across-the-board cuts will be
assigned to all stations by the ship's computer.  To avoid this,
reallocate for the lower setting before actually changing the setting.
A few points are typically lost due to the inefficiency of the shortfall
process.

Reactor setting is given as a percent of the maximum output.  A certain
level, typically between 70% and 80%, is the highest setting that can be
maintained indefinitely.  Above this level, the dilithium crystals begin
to overstress.	When they are close to their maxumum stress level, the
engineer will receive warning messages.  At 100% stress, the computer
will automatically set the reactor down to it's maximum sustainable
level.	Energy shortfalls will then usually result.  At levels below the
maximum sustainable level, crystal stress is gradually reduced.  Crystal
stress will not appear on the engineering report unless there is some.

Ship's batteries can be either on line or off line.  While off line,
they can do nothing except recharge as the allocation to batteries is
added to their level every turn.  While on line, they will add their
maximum output per turn to the available power the engineer has to
allocate.  In addition, one half of one percent of the total available
power in the batteries is lost each turn spent online due to power
bleeding off.  However, if there is a shortfall in the available power
and batteries are on line, they'll be used to cover as much of the
shortfall as possible.

Engineering commands are:

start reactor - 	Brings the reactor online.  The ship will not
			function until this command is given.

shutdown reactor -	Brings the reactor offline.  The ship will
			essentially cease to exist until the reactor is
			started again.

status -		Gives a complete report of the engine, battery, and
			allocation status.

set reactor<#> -	Sets the reactor output level to # percent.

batteries on/offline -	Brings the batteries on or off line.

allocate <helm> <nav> <batteries>:
			Allocates the given amounts, not percents, of
			energy to the various stations.  Note that if
			more energy is allocated than is available,
			across-the-board cuts will be assigned,
			resulting in less than ideal efficiency.

toggle warnings -	Turns the warning messages off or on.

toggle safeties -	Enables/Disables the automatic reactor override
                        cases of crystal overstress.

warp table -            Just like the nav command.  Gives a list of costs
                        for various warp speeds.


Navigation:

Energy allocated to navigation is further allocated by the navigator to
warp drives and shields.  Power allocated to shields is added to their
levels every turn.  Shields can be either up or ready.	While ready,
they can be charged but are not engaged and will not protect the ship.
While up they will block incoming weapon fire.	Shields lose 1% of their
charge every turn while ready, and 10% per turn while up.  Each shield
has a maximum power level, maximum overload level, and an energy factor.
The maximum power level is the normal max for the shields.  Shields can
be overloaded by allocating extra power.  All power in excess of the
maximum is lost at the end of the tactical turn, instead of just 10%.
The shields can be overloaded to the maximum overload level.  The energy
factor determines how many shield power points come from each allocated
point.	This number will usually be somewhere near one, with large ships
that need large shields requiring more power per point, and small ships
requiring fewer.

Shield protection areas are somewhat complicated.  The four shields
together form a protective sphere around the ship.  The forward shield
is defined by a cone centered at the ship extending forward along the
ship's axis.  Anything striking the shield within 60 degrees of this
axis will hit the forward shield.  The cone is thus 120 degrees wide.
The aft shield is identical, but reversed.  The remaining 60 degree
bands to the sides of the ship are the port and starboard shields, which
join at two seams along the top and bottom.  Note that the fore and aft
shields never connect.

If this is hard to visualize, imagine a striped billiard ball.	One half
of the stripe is the port shield, the other half is the starboard
shield.  The circular zones ahead and behind are the fore and aft.

All navigation is handled in spherical coordinates.  The ship's position
is given relative to the HUB, or another planet if you have configured
it to do so, and the positions of other ships are given relative to the
position of your ship.	Bearing and elevation to target are true, not 
relative, meaning that a target that is spinward of you is at 90 degrees, 
regardless of your facing.

Cloaking devices require little power, but they use the shield
generators to function.  Therefore, shields can not be used while cloak
is engaged.  Further, all shield generators must be undamaged for the
cloak to work.	When cloak is engaged, all shields are lowered and all
power allocated to them is lost.  If shields are raised while cloak is
engaged, cloak will be automatically disengaged.

Navigation commands are:

status		      - Gives a status report on ship's position,
			orientation, shields, and allocation.

set heading <bearing>+/-<elevation>:
			Sets the ship's bearing and elevation.

set warp <warp factor>- Sets the warp speed of the ship if sufficient
			energy is allocated to drives.

warp table	      - Gives a list of the energy costs for various
			warp speeds.

warp cost #	      - Gives the energy cost for a specific warp speed.

allocate <warp> <fore> <aft> <port> <starboard>:
			Allocates power to warp and the four shields.

qalloc <warp> <shields>-Allocates power to warp and shields.  Allocation
			to shields is evenly divided among the four shields.

raise shields	      - Brings all undamaged shields up.

lower shields	      - Sets all undamaged shields to ready.

raise/lower shield <shield>:
			Raises or lowers a specific shield.  Specify
			fore, aft, port, or starboard.	Be sure to use
			lower case.

cloak on/off	      - Engages/disengages cloak, if available.

contact list	      - Gives a list of all current sensor contacts and
			all known information about them.

report <ship>	      - Gives the contact report for <ship>

planet list	      - Lists all planets in sensor range.

coordinates <planet name> label <label> - Configures the nav console to
                        report ship position relative to <planet name> instead
                        of the HUB, labeling the output with <label> instead 
                        of HRC.

reset coordinates     - Resets the nav to hub-relative coordinates.

dock <target>	      - Docks your ship at <target> which can be either a
			name or contact number.

undock		      - Used to leave spacedock.


Helm:

The helmsman receives all information about sensor contacts and
tracking.  Every sensor contact will have a designated number.	This
number can be used for scanning, locking, and firing.  If you manage to
get the name of a ship, that can be used as well.

Phaser banks can be either on line or off line.  While on line, they
draw a share of the total allocation to phasers.  In addition, while up
they lose 20% of their allocation per turn.  Phasers never miss, but
they do less damage to targets farther away.  Disruptors work exactly
the same way.

Photon torpedoes are armed by bringing them online.  They then draw a
share of the allocation to photons.  Once they've received enough power,
they become armed and may be fired.  Photons that are not fired within
approximately 50 seconds of when they begin to charge will be discarded.
They cannot be charged and held for any long period of time.  Photons
always deliver the same damage, regardless of the distance to the
target.  The chance of hitting a target drops with greater range, and is
also modifed by the size of the target.  Small ships are tough to hit.

It takes around thirty seconds to reload a photon, and only one tube can
be reloading at a time.  Be sure to wait until one tube is reloaded
before giving another reload command, as the first tube will be
abandoned in lieu of reloading the new tube.

Auto-arm is a special option that automatically arms all loaded
torpedoes, and immediately arms any that are later reloaded.  Be sure to
turn this off when you're done fighting.

Any contact on the list may be scanned.  This gives a tremendous amount
of information about the target.  It also makes your ship much easier to
detect.

Helm commands are:

sensor report -       Gives a list of all present contacts.

report <ship> -       Gives the contact report for <ship>

scan <ship> -	      Scans <ship>.  Use name or contact number.

lock <ship> -	      Locks weapons on <ship>.

unlock weapons -      Removes the current weapons lock.

status -	      Gives a report of all weapon status and lock data.

allocate <phasers> <photons>:
		      Allocates energy to phasers and photons.

photon # on/offline - Brings the specified photon on or off line.  Note
		      that this command is overridden by the auto-arm command.

fire photon <tube>  - Fires photon tube <tube>.

reload tube <tube>  - Reloads photon tube <tube>.  This must be done
		      after every shot.

fire all photons    - Fires all available photons.

phaser # on/offline
 -or-
disruptor # on/offline:
			Brings phaser bank # on or off line.

fire phaser #, fire all phasers:
 -or-
fire disruptor #, fire all disruptors:
			Fires the specified bank.

toggle autoarm -	Turns the auto-arm feature on or off.

toggle autoload -       Turns the auto-load feature on or off.

Note that the word 'gun' can be substituted for phaser or disruptor in
any command.


Reactor:

Each reactor has a maximum output.  The amount of power it puts out is
the maximum output times the reactor setting / 100.  At power levels
above a given setting, typically 70-80%, crystal stress will accumulate.
When the crystals get within one minute of overload, warning messages
will begin.  When the crystals reach 100% stress, the reactor will
automatically drop to it's optimum setting.  The stress won't go away at
this setting, but no more will pile up either.	To get rid of crystal
stress, set your reactor level below the optimum setting.  The stress
will eventually go away.

See also entries on: engineering, engcommands, batteries


Batteries:

Ship's batteries can be either online or offline.  WHen offline, they do
nothing.  When online they add to the amount of power the engineer has
to allocate.  However, 0.5% of the total battery charge is lost every
turn spent online.  To recharge batteries, just allocate power to them.


Phasers:

Phasers may be either on line or off line.  While off line, they do
nothing at all.  While on line, they draw an equal share af the
allocation to phasers every turn.  They lose 10% of their power to
bleedoff every turn they're online, and will not 'store' power if they
go offline.  Phasers never miss, but the damage they do falls as the
range to the target increases.


Photons:

Photons may be empty, loaded, charging, or armed.  They start out
loaded.  When a photon is brought on line, it begins to draw an
equal share of the energy allocated to photons.  A message is flashed to
the helmsman when the torpedo becomes armed.  Photons always deliver the
same damage, regardless of the range, but the chance of hitting the
target falls as the range increases.

Once a photon is set online, it must be fired within approximately
ninety seconds or it will be lost.  Note that this is ninety seconds from
when it's brought online, not from when it's armed.

When a photon is fired or expires, the tube becomes empty.  You must
reload the tube before you can bring it online again.  NOTE:  Only one
tube can be reloading at a time.  If a tube is reloading and you give
the order to reload a different one, the first one will be abandoned and
the second will be loaded instead.  Loading a torpedo takes
approximately thirty seconds once the command is given.

If you set the autoarm on, photons will immediately come on line upon
being loaded.  If you set the autoload on, a new photon tube will begin
loading any time no other tube is loading and there's an empty tube.


Sensors:

Sensors are passive.  They detect emissions from other ships and
identify them from these emissions.  When a new contact is acquired, or
an existing contact is improved, a message will flash to the helmsman.
Every contact has a number that can be used in place of the name for
locking and scanning.

Sensors are more effective against ships that are large and moving fast,
and less effective against a small and slow-moving target.


Scanners:

Scanners are active.  You probe the target with signals and get
information from what you get back.  The target ship will be aware of
the scanning, and it will contribute to their chance of detecting you.
When you scan, you get information about the target's shield status,
weapon and warp allocations, and hull integrity.  Scanners have a
maximum range that is typically far less than the range at which you
will acquire a target.


Docking:

     To dock with a starbase, do the following:  Get within five units,
cut your engines, lower shields, get the base to lower the shield facing
you and open their door, and type 'dock <target>' where <target> is
either a base name or contact number.

Type 'open doors' or 'close doors' from nav on the starbase to toggle
the doors.


Coordinates:

     All coordinates are given in spherical format, that is, bearing and
elevation.  The axes look like this:

			    coreward
			       0
			       |
			       |
			       |
	 antispinward 270------+------90 spinward
			       |
			       |
			       |
			      180
			    outward

The names of the directions refer to the position of the HUB if one of
the arms of the galaxy.  Spinward is in the direction of galactic spin.
Coreward is toward the galactic core.  Up, used for elevation, is the
direction such that if you were to look down, you'd see the galaxy
rotating anticlockwise.

Elevation is the tilt of your ship, always between -90 and +90 degrees
inclusive.  The position of your ship is always reported relative to the
hub.  The positions off all other ships are reported relative to your
position.

Two sets of coordinates define a ship.	One gives your position, and one
gives your orientation.  Positions are usually listed as bearing,
elevation, and range.  Orientations are usually listed as heading,
elevation, and speed.  The difference between heading and bearing is
that bearing is where the target is, relative to you.  Heading is which
way he's going.


Warp:

Warp drives are the only way to move a ship.  Sublight is way to slow to
ever get you anywhere, so we don't even mess with it.  Type 'warp table'
to get a list of costs for various warp speeds.  This will differ from
ship to ship.  'warp cost <speed>' will work too.  We're using floating
point here, so speeds like 5.4 are usable.  Warp speeds translate to
movement as follows:  Ships move every two seconds.  They move a number
of units equal to their warp speed cubed.  Since warp costs start out
high, typically around three hundred, but then grow rather slowly, the
high warp speeds are most efficient in terms of speed per point
spent.	To use the drives, first allocate energy to them.  Then type
'set warp <speed>' and you're off.  'set warp 0' or 'full stop' will
disengage the drives.


Cloak:

Cloaking devices interfere with most of the electromagnetic spectrum to
block emissions from leaving or bouncing off the cloaked ship.	This
renders the ship effectively invisible, and almost completely impossible
to detect with passive sensors.

The cloaking device uses the shield generators to function.  To operate
it, allocate the required amount of energy, typically between 40 and
180, to shields, divided up in any way so as to total the required
amount.  You may then turn the cloak on.  This automatically lowers the
shields and discards any energy stored in them.  Raising shields
automatically disengages the cloak.

Note that if any of the shield generators get damaged, the cloak will
cease to function.

While cloaked, it IS possible to be detected.  Various factors can
contribute to your detection, among them are movement at warp speeds,
high reactor settings, arming weapons, or locking weapon directors.


Shields:

Shields protect ships from weapon fire.  Every turn shields lose some of
their energy to dissipation, and then receive the allocated amount.

The shield status line contains three data for each shield.  The level
is the amount of energy stored.  The two status registers can read any
of the following:

       READY   -   Shield is down.  It will not block any incoming fire,
		   but it can be raised on short notice and will only lose
		   1% of its' charge to routine dissipation.
       UP      -   Shield is up and protecting the ship.  It will lose
		   10% of its' charge every turn to dissipation.
       DMGD    -   Shield is damaged and offers no protection.	It
		   dissipates according to the level when it was damaged.

       CHARG   -   Shield is charging.	That is, they're at a higher
		   level than they were at last turn.
       FALL    -   Shield is falling.  It's at a lower level than last
		   turn.
       OVRLD   -   Shield is overloaded.  Any shield energy in excess of
		   maximum for that shield is lost every turn due to
		   dissipation.  This is inefficient, but offers much
		   extra protection.
       ----    -   Shield is damaged and this last status doesn't
		   matter.


Example of navigation:

Suppose we have 400 points allocated to nav and we're on routine
cruising.  We check the warp table and find that warp 5 costs 360
points.  We type 'qalloc 360 40' to give us enough energy for warp 5 and
ten for each shield.  We'll keep the shields down to reduce dissipation
so our ten per shield will eventually get the shields fully charged.  We
then go on our way.

Later we get scanned by an unknown source.  Or maybe weapons lock, if
the unknown source is in a bad mood.  Either way, the first thing we do
is raise shields.  Dissipation is going to kick in now and our shields
will eventually fall to 100 if we don't change our allocation.  We have
two choices: cut warp speed or yell at engineering for more power.  Lets
do the former for now, since the engineer will probably be giving any
new power to the helm.	We don't need to reset the warp speed to slow
down.  Changing the allocation will do that automatically.  First off,
get all the shields good and strong.  'qalloc 0 400' will do nicely.
They'll all be good and overloaded.

Suppose he locks weapons and we spot him bearing 160 degrees.  First we
type 'set heading 160+0' to face him.  Then 'allocate 0 310 30 30 30' to
pump up the fore shield.  This is more energy than the shield can
handle, even with overload, but it'll grow back in a big hurry if he
shoots us.  In combat, our job is to keep strong shields facing the
enemy.	That's why shields and orientation control go to the same guy.
If one shield fails, we have to quickly present another to the hostile.

==========
Note:  Due to changes in the code, the above example is a shade
misleading.  Every shield has a maximum charge per turn, beyond which
any allocated power is wasted.	Allocating 310 to the forward shield is
almost certain to waste over 100 units of power.  The maximum charge per
shield can be easily determined experimentally, and varies from ship to
ship.
==========

Suppose the attacker is a scout.  His guns won't get through our
shields.  Too bad.  One scout later, we're on the road again.  We lower
shields and return to our previous allocation, set the old course, and
engage warp again.


Example of helm operation:

Okay, we're cruising around at warp 5 or so.  We only have 50 points
allocated to helm.  Since phasers bleed at 10%, we can maintain 500
points of phasers with that allocation, so we'll bring both banks on
line.  Now we just sit and wait.  The helmsman's job is kinda dull until
a fight starts.  We'll set the 'toggle autoload' on since it's a
generally cool thing to have in a fight.  No good reason to leave it
off.

Poof.  Now contact bearing 160 range 1300.  This is bad.  For him to pop
on sensors at that range he must be decloaking.  Since he hasn't locked
weapons or scanned, the navigator doesn't know about him yet.  First
thing we do is holler. '"decloaking ship.'  Keep it terse, since speed is
important.  The navigator will now worry about the shields and we can
concentrate on guns.  Next we tell the engineer that we need more power.
Ship com channels are ideal for this.  '+com Myship=Bad guy.  Gimme more
juice.'  The engineer will now probably gun the reactor to 100% and
bring the batteries online.  We can expect a couple hundred units.

Since our bad guy hasn't done anything nasty yet, the captain will have
to play some verbal games for now.  Lets suppose, though, that we're at
war or something and have orders to fire on sight.  The first thing we
do is fire any guns we have ready.  'fire all phasers'  Who knows.
Maybe he forgot to raise shields or something.	Next, we reallocate.  We
don't know exactly what the engineer gave us without doing a status, and
we're sort of in a hurry, so we just type 'allocate 500 1000'  We don't
have that much, but that'll allocate one third to guns and two thirds to
photons.  Suppose we've got 300 to work with.  That's 100 for guns and
200 for torps.	Keeping in mind that expiration time on torps, and the
fact that ours require 150 points to charge, we bring only two on line
for now. 'photon 0 online' 'photon 1 online'  Save the guns.  Once torps
are armed, we 'fire all photons' and 'fire all guns'  It's best to hit
them fast than to spread out the fire and lets their shields grow back.
Next we 'reload tube 0' and 'photon 2 online' 'photon 3 online'

The battle will continue like this.  Remember that we can only reload
one tube at a time.  Perhaps a better strategy would be to allocate
everything to torps and 'toggle auto' to arm them all.  Then fire all
four at once.  After the torps are used, though, you're relying on guns
for awhile.  Lets 'allocate 300 0' until more torps are loaded.  No
sense wastin energy, and this will give us a solid phaser shot every 6
seconds.  We'll continue like this until at least two tubes are
reloaded.  Then we reallocate and start over.

Eventually, we kill the bad guy.  Expect an allocation cut.  Sure
enough, we're back to 50.  We 'toggle auto' again if we turned it on in
the first place.  We then 'allocate 50 0' to charge up our phasers and
'reload' any tubes that are empty, which is likely to be all of them.
Back to business as usual.

==========
Note:  The above example, while somewhat informative, is also an example
of many things to NOT do.  First off, some factual inaccuracies.  Due to
code changes, the helmsman is now informed when his allocation rises,
not just when it falls, so that kind of guessing game isn't neccesary.
Next, the example doesn't show our helmsman actually locking weapons on
the bad guy.  Oops.  Finally, arming only two torps is, frankly, stupid.
The way to fight is to hit the target with everything you've got all at
once.  Using half your torps at a time simply means that you'll have to
knock down his shields twice instead of once before you can hurt his
hull.
==========


Example of engineering operation:

Okay, we're on a routine cruise.  We 'start reactor' and 'reactor
setting 75' since that's the normal optimum level for this ship.  That
might give us 450 points.  We're at war patrolling hostile territory, so
an attack is very likely.  Keeping this in mind, we allocate a healthy
amount to helm so that we have guns ready on a moment's notice.
'allocate 50 400' is the order.  Now we sit back and play cards or
something.  Maybe go work on that broken intercom.

Intercom> Bob the helmsman says "Bad guy.  Gimme more juice."

Okay, first thing is crank the reactor up to 100%.  Levels above that
are possible, but they're not worth it.  'set reactor 100'  That
gives us maybe 600 points.  The navigator is going to need all of his
400 for shields, so we give the extra to helm.	'allocate 200 400 0'
Next, we get the batteries going.  'batteries online'  They can put out
250 per turn.  Lets' use 100 of that and keep the rest in case of a
shortfall.  Besides, this way our batteries will last longer.  It may be
a long fight.  'allocate 300 400'  The extra 100 will automatically come
from batteries.  Now, since our batteries are at 3000, 100 per turn will
deplete them in 30 turns times six seconds, or around three minutes.
Less than that, considering that they bleed when they're online.

Now we just listen and react.  If it's gonna be a stand still and fight
routine, we may give some of nav's energy to helm.  If we're gonna try
and keep the bad guy at a distance, we'll want to allocate more to nav.
If we're going to flee entirely, we crank the reactor up to max levels
'set reactor 110' and then 'allocate 0 2000 0' to make sure that nav
gets everything.  This burst of speed won't last much more than a
minute, but we'll probably be able to turn warp 11 or so at emergency
max output.   That'll get us out of the battle in one big hurry.

==========
Note:  The above example has some factual errors due to code and
template upgrades.  First off, the battery specs listed are unrealistic.
Batteries discharge less energy per turn, and run down far more slowly.
Most batteries will last several minutes at full discharge.

Secondly, the statement that 'it's not worth' going above 100% is
somewhat arbitrary.  Most ships can last for 5-7 minutes at full
overload power, and the extra energy can make a big difference.  It
certainly is worth going that high on many occasions.
==========

Communications:

The comm console allows the ship to communicate with other ships,
planets, and bases.  The system is based on channels, frequencies, and
labels, as explained below:

   frequency - The identifier for a message route.  Frequencies between
	       1 and 65535 are available.  When a message goes out over
	       a given frequency, any ship in range of the transmitter
	       who is monitoring that frequency will receive the
	       message.

==========
Note:  Frequencies MUCH higher than 65535 are available.  Really BIG
numbers are allowed too.  Experiment.  You won't crash us or anything.
==========

   channel - A register in the comm console.  Each ship has six
	     channels, and each can be set to a different frequency.
	     For example, channel 0 might be set to monitor frequency 1,
	     the standard hailing frequency.  Channel 1 might be set to
	     monitor frequency 9, the standard distress frequency.

   label - The name assigned to a channel by the comm operator.

The difference between frequencies and channels is very important and
somewhat subtle and is certain to cause a great deal of confusion, so
read carefully.  The frequency is the only really meaningful number.
Frequency 457 is frequency 457, no matter who is listening.  One ship
may have channel 4 set to frequency 457 and label is 'fleet ops' and
another ship might have channel 2 set to frequency 457 and label it
'StarFleet HQ', and they'd use different commands to transmit, but it's
still the same frequency.  Channel numbers and labels are arbitrary.

Communications commands are:

status				  - Lists each channel, frequency,
				    label, and settings.

set <channel>=<frequency>	  - Sets <channel> to <frequency>

close <channel> 		  - Closes <channel>

comm <channel>=<message>	  - Sends <message> over the frequency
				    of <channel>

label <channel>=<message>	  - Sets <channel>'s label to <message>

send <channel>=<setting>	  - Sets the send status of <channel> to
				    <setting>.	See below for a list of
				    valid settings.

receive <channel>=<setting>	  - Sets the receive status of <channel> to
				    <setting>.	See below for a list of
                                    valid settings.

Valid channel settings:

local	- Only the comm officer can send/recieve.

audio	- Any incoming messages come over the bridge speaker.  Anything
	  said on the bridge gets sent.

visual	- Like audio, but posing, etc., is sent/recieved as well.


If two communicating ships have incompatible settings, the results are
somewhat predicatble.  If no visuals are being sent, none will be
received, regarless of the setting of the receiving ship.  If visual
signals are being sent by one ship, listeners must be set for visual as
well to hear anything at all.  Regardless of incompatibilities, anything
sent directly by the comm officer will be received.


Example of comm operation:

I'm the comm officer aboard USS Leonov, a Federation Nebula-Class light
cruiser.  Immediately upon the startup of the ship, I set up the
channels.  1 is standard hailing freq, 9 is standard distress, and 35764
is the StarFleet orders channel for now, although this changes
frequently.  I set them with the following commands: 'set 0=1' 'set 1=9'
'set 2=35764'  And now I label them so that if I put them on speaker,
the bridge crew knows where they're coming from. 'label 0=hailing'
'label 1=distress' and 'label 2=StarFleet HQ'  That leaves me channels
3-5 open.  In the course of our travels we encounter a Ferengi vessel.
The captain orders me to hail the vessel.  Channel 0 is my hailing
frequency, so I type 'comm 0=Hailing Ferengi Merchant Cruiser.  Please
respond on channel 99'  Choice of frequency is purely arbitrary,
but it's customary to let the hailing vessel choose the frequency.  I
then 'set channel 3=99' to be listening for their reply.  When they
reply, I say "Communications opened, Captain."  Since standard operating
procedure on this ship is to put new hails on the speaker, I do so.
'receive 3=audio'  That way everyone on the bridge can hear
what's going on. Furthermore, standard procedure is for the Captain to
chat with the other ship, so I 'send 3=audio' so that they can
hear him.  I'll privately chat with their comm officer to get him to set
his audio up too.

That's about it.  When we go on our way, I drop the channel for security
reasons.  Or maybe stay on it but not transmit.  I'll continue to amuse
myself during our trip by flipping frequencies at random, hoping to
stumble across something interesting.


Damage Control:

When ship systems get broken in combat, you use the damage control
console to effect field repairs.  Systems that you fix in the field will
generally work about 90% as well.

Damage control commands are:

system status		    - Gives a list of all damaged/field repaired
			      systems and their condition..

team status		    - Shows what each of your damage control
			      teams is up to.

team # fix/repair <system>  - Assigns team <#> to work on <system.>

Special Starbase Only Commands:

repair <shipname>           - Begins the repair process on 'ship'.  This
                              takes six hours.  Interrupting the process
                              by taking the ship out of dock will result 
                              in no damage being repaired, and a full six 
                              hours being needed next time.	

sick list                   - Lists all ships under repair and the
                              estimated time until completion.


Transporters:

Use the transporter console to beam to other ships, bases, and planets.
You can beam to any target in range while in space.  If you're docked,
you can beam to the ship you're docked with, as well as any other ships
in the dock with you. 

Commands are:

coords              - Gives a list of ships, planets, and bases you can
                      beam to.

lock <target>       - Locks the transporter beam on <target>.

dests               - Gives a list of places on the locked target that
                      you can set to beam to.

target <place>      - Sets the transporter beam to a specific location
                      on the locked target.

prep/unprep         - Get ready/not ready to transport.  All prepped
                      persons will get beamed in a group.

engage              - Go.


Starbases:

Starbases are different from other ships in a few important respects.
First off, they can't move or even change heading.  You can dock with
them, and their consoles are set !key to allow automation.

To help with automation, a special @listen-friendly command is available
from starbase helms.  ID <target> is the command.  Target can be either
a ship name or a contact number.  All the information will be output on
one clearly parsed line to make listen parsing a snap.  You're welcome.


Space security:

Any time a console is manned, it will give the following command:

<console name> manned by <manner name> number <their ID#>

This is a typed command, not an @emit, so you'll need a $command to
catch it.  A nice and airtight application of this that requires no
cpu-intensive @listens or db-intensive objects is to put the following
line of code in the ship org and attach the bridge and engineerinr
rooms.

$* manned by * number *:@swi name(owner(%#))=Space,{@swi v(xa)=*%2
#*,,{@swi rank(%2)=17,,do_something_nasty_to %2}

XA is a list of id's of authorized persons, with an extra # at the end
to serve as a delimiter, like so:

XA: #13092 #333 #2410 #2 #4359 #1297 #8294 #end


Realspace protocol:

The following are a set of guidelines for conduct in realspace.  These
are merely suggestions.  Any orders from your fleet command take
precedence over these rules.

Again, let me emphasize that there are GUIDELINES.  These merely serve a
s model for how ships thould act in realspace.  These are NOT enforced
by the directors.  Ships are NOT required to follow these rules.  But if
most people do, things will go more smoothly.

I. Patrol
   - Ships with cloak capability should patrol while cloaked with no
power to weapons and minimum power to maintain cloak.
   - Ships that cannot cloak or choose to patrol without should do so
with at least one gun online and fully charged, and all shields ready
and fully charged.  This should require little power, allowing for
typical cruise speeds in the neighborhood of warp 6-8.
   - Ships should never patrol without a minimum crew of 3.  That's
engineer/damage control, helm/comm, and navigation.  Ships with fewer
than three crew are likely to get the snot kicked out of them by ships
without this deficiency.

II. Contact
   - Notify fleet ops and close to scanning range while attempting to
open communications.  Hail on frequency 1.  Do not lock weapons or raise
shields.
   - Once in range, scan frequently to keep tabs on weapon/shield
configurations.  Scanning is not an unfriendly maneuver.  Don't get
upset if they scan you.
   - Once communications are opened, pick another frequency and move to
it.  The hailing ship should suggest a frequency.
   - Identify the ship and determine intent.  Do not harass, stop, lock
onto, or otherwise molest merchants without specific orders to do so.
Your economy depends on them.
   - If the vessel is a foreign warship, notify one of your diplomats
immediately, then politely offer to escort the warship to the nearest
border.
   - Special cases:
   -- Closing to within 4K while cloaked is A Hostile Move.  If you see
a cloaked ship that close, raise shields and begin arming photons
immediately.  Do NOT scan a cloaked ship.  They might not know that you
see them.  Only scan if they decloak, or after your torps are armed. 
   -- Ships that don't respond to hailing:  Keep your distance.  Adopt a
parallel course and match speed.  If they close, raise shields and be
prepared to defend yourself.  Try hailing on the War channel if you have
to, but this is generally A Bad Idea.
   -- Obviously, any ship that locks weapons or fires is unfriendly and
should be treated accordingly.  If he's bigger than you, run and call
for help.  If the fight starts going sour, run.  Don't wait until your
hull gets down below 50%.  Run once it becomes clear that you stand
better chances of losing than winning.  Running isn't cowardly if you're
outgunned.  Ships are expensive to replace and new captains are easy to
find.

III. Oops
   - You stumble into foreign space and get caught.  Keep in mind that
YOU are the invader.  Do what the other guy says.  If he says to drop
cloak, or take weapons offline, do it.  If he says to cut your engines
or lower shields, do it.  If they want to board for a customs
inspection, allow it, but don't let them leave anything behind and keep
armed escorts handy.  The only requests that are unreasonable are that
you depower ready shields, stop scanning, or permit them to lock
weapons.  If the other ship wants you to do any of these things, you're
in serious trouble and should run immediately.  If you're polite, claim
navigation error, and apologize profusely (you might want  to get a
diplomat to apologize for you.  They're better at it,) you'll probably
get out of there without further trouble.  

IV. Unclaimed space
   - Unclaimed space is open turf.  All are welcome.  The Fed/Rom
neutral zone is, by treaty, off limits to Feds and Romulans.  Others may
ignore it.  Don't pick fights in neutral space.  Don't get cheeky and
use your cloak to rattle people.  Don't get all uptight if a cloaker
gets within 4k, as long as it could possibly be an accident.  In short,
don't take any crap, but try and be reasonable too.  Remember, the other
guy might have buddies nearby that you aren't aware of.  One versus many
fights tend to deteriorate in a hurry, and disengaging can get sort of
dicey.

V. Transporters
   - Transporters let you beam to sensitive parts of ships.  Don't.
Protocol demands that you beam only to the transporter room, unless you
have special permission.  Beaming directly to the bridge or eingineering
sections is unfriendly.


Repair:

To repair a sim, simply type 'repair' at the damage control console
while inactive.  Pow.  All fixed.  Neat, huh?

If a real ship gets damaged, dock it.  Then use the damage control
console of the starbase to fix the ship.  Look under help damage control
for details.


The Hub:

The Hub is a starbase located at a point equidistant from the capitals
of the 'big three' empires.  It is a mighty starbase, and attacking it
is a good way to get stomped.  It will defend itself if fired upon.  It
may also fire on any ships who fire at targets within 8000 units of it,
or fire from within said limit.  It will not always enforce the zone,
but it's still a risky proposition.	

Effective 19 September, The Hub will fire on ANY vessel that locks
weapons on it.  The Hub is pretty to look at.  Be sure that's all you
do.

Randy, the Hub officer of the deck, is monitoring frequency 4077 on the
comm units.  Requests of open to close the doors can be sent on that
freq and she'll cooperate.  You can also ask her to lower the shields,
but she won't do it if anyone has locked weapons.

Randy is also monitoring freq 10111.  Soon she'll stop listening to
4077, so start using 10111 instead.

